> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/dsx-air/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/dsx-air/_mcp/server.

# Update individual fields of an instruction

PATCH https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/{id}/
Content-Type: application/json

Update specific fields of the instruction. This operation is only permitted when the simulation is in the `ACTIVE` or `INACTIVE` state and the instruction is not in the `IN_PROGRESS` state.

**Required scope:** `air:simulation_edit` (roles: `air_org_admin`, `air_user`)

Reference: https://docs.nvidia.com/dsx-air/api-reference/instructions/api-v-3-simulations-nodes-instructions-partial-update

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `id` (string, required) — A UUID string identifying this instruction.

### Body (application/json)

This endpoint expects an object.

- `name` (string, optional) — The name of the instruction.
- `run_again_on_rebuild` (boolean, optional) — If the instruction should be run again if the simulation is rebuilt.

## Response

### 200

- `object or object or object`
  - InitInstructionRead
    - `id` (string, required)
    - `created` (datetime, required)
    - `modified` (datetime, required)
    - `node` (string, required) — The node which will execute the instruction.
    - `data` (object, required) — Data on what hostname should be assigned to the node when it initializes.
      - `executor` (enum, required) — The `init` executor option. * `init` - init
        - Allowed values: `init`
      - `hostname` (string, required) — Hostname to assign to the node when it initializes.
    - `state` (enum, required) — The current lifecycle state of this instruction. Defaults to NOT_READY; transitions to READY once the target VM is running. * `NOT_READY` - The instruction exists but is not yet ready for worker pickup. * `READY` - The instruction is ready to be picked up and executed. * `IN_PROGRESS` - The instruction has been picked up by the worker. * `COMPLETE` - The instruction was successfully executed. * `FAILED` - The instruction failed to finish execution. * `CANCELLED` - The instruction was cancelled before execution.
      - Allowed values: `NOT_READY`, `READY`, `IN_PROGRESS`, `COMPLETE`, `FAILED`, `CANCELLED`
    - `created_by_client` (boolean, required) — Whether the instruction was created by a client.
    - `wait_for_network` (boolean, required) — Whether to wait for network connectivity before executing the instruction.
    - `reachability_check` (any, required, nullable) — Configuration for network reachability check. None when wait_for_network is False or not set.
    - `name` (string, optional) — The name of the instruction.
    - `run_again_on_rebuild` (boolean, optional) — If the instruction should be run again if the simulation is rebuilt.
  - FileInstructionRead
    - `id` (string, required)
    - `created` (datetime, required)
    - `modified` (datetime, required)
    - `node` (string, required) — The node which will execute the instruction.
    - `data` (object, required) — Information needed to write files to the node.
      - `executor` (enum, required) — The `file` executor option. * `file` - file
        - Allowed values: `file`
      - `files` (list of object, required) — List of files to write to the node.
        - `path` (string, required) — Path on the node where the file will be written.
        - `content` (string, required) — Text content to write into the file.
      - `post_commands` (list of string, optional) — List of shell commands to run, in order, after the files are written.
    - `state` (enum, required) — The current lifecycle state of this instruction. Defaults to NOT_READY; transitions to READY once the target VM is running. * `NOT_READY` - The instruction exists but is not yet ready for worker pickup. * `READY` - The instruction is ready to be picked up and executed. * `IN_PROGRESS` - The instruction has been picked up by the worker. * `COMPLETE` - The instruction was successfully executed. * `FAILED` - The instruction failed to finish execution. * `CANCELLED` - The instruction was cancelled before execution.
      - Allowed values: `NOT_READY`, `READY`, `IN_PROGRESS`, `COMPLETE`, `FAILED`, `CANCELLED`
    - `created_by_client` (boolean, required) — Whether the instruction was created by a client.
    - `wait_for_network` (boolean, required) — Whether to wait for network connectivity before executing the instruction.
    - `reachability_check` (any, required, nullable) — Configuration for network reachability check. None when wait_for_network is False or not set.
    - `name` (string, optional) — The name of the instruction.
    - `run_again_on_rebuild` (boolean, optional) — If the instruction should be run again if the simulation is rebuilt.
  - ShellInstructionRead
    - `id` (string, required)
    - `created` (datetime, required)
    - `modified` (datetime, required)
    - `node` (string, required) — The node which will execute the instruction.
    - `data` (object, required) — Information on shell commands to be run on the node.
      - `executor` (enum, required) — The `shell` executor option. * `shell` - shell
        - Allowed values: `shell`
      - `commands` (list of string, required) — List of shell commands to run on the node, in order.
    - `state` (enum, required) — The current lifecycle state of this instruction. Defaults to NOT_READY; transitions to READY once the target VM is running. * `NOT_READY` - The instruction exists but is not yet ready for worker pickup. * `READY` - The instruction is ready to be picked up and executed. * `IN_PROGRESS` - The instruction has been picked up by the worker. * `COMPLETE` - The instruction was successfully executed. * `FAILED` - The instruction failed to finish execution. * `CANCELLED` - The instruction was cancelled before execution.
      - Allowed values: `NOT_READY`, `READY`, `IN_PROGRESS`, `COMPLETE`, `FAILED`, `CANCELLED`
    - `created_by_client` (boolean, required) — Whether the instruction was created by a client.
    - `wait_for_network` (boolean, required) — Whether to wait for network connectivity before executing the instruction.
    - `reachability_check` (any, required, nullable) — Configuration for network reachability check. None when wait_for_network is False or not set.
    - `name` (string, optional) — The name of the instruction.
    - `run_again_on_rebuild` (boolean, optional) — If the instruction should be run again if the simulation is rebuilt.

## Errors

### 400 Bad Request Error

- `detail` (string, required) — Description of an error.
- `request_id` (string, required, nullable) — ID assigned to the request which encountered the error. Should be provided when opening a support case.
- `type` (enum, required) — Specific type of a 400 error. * `PROTECTED` - Instance may not be deleted as it is being referenced by other instances. * `VALIDATION` - Validation errors encountered during payload processing.
  - Allowed values: `PROTECTED`, `VALIDATION`
- `protected_instances` (list of object, optional) — Instances which bar the current instance from being deleted. Only defined when `type` is set to `PROTECTED`.
  - `id` (string, required) — ID of the instance.
  - `type` (string, required) — Type of the instance.
- `validation_errors` (map from string to list of object or object or map from string to any or list of object, optional) — Validation errors encountered during payload processing. Only defined when `type` is set to `VALIDATION`.

### 403 Forbidden Error

- `detail` (string, required) — Description of an error.
- `request_id` (string, required, nullable) — ID assigned to the request which encountered the error. Should be provided when opening a support case.

### 404 Not Found Error

- `request_id` (string, required, nullable) — ID assigned to the request which encountered the error. Should be provided when opening a support case.
- `detail` (string, optional, default: No object matches the given query.) — Description of an error.

### 500 Internal Server Error

- `request_id` (string, required, nullable) — ID assigned to the request which encountered the error. Should be provided when opening a support case.
- `code` (string, required) — Error code which identifies the error. Should be provided when opening a support case.
- `detail` (string, optional, default: An unexpected error has occurred. Please contact NVIDIA Air support for further assistance.) — Description of an error.

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "created": "2024-01-15T09:30:00Z",
  "created_by_client": true,
  "data": {
    "executor": "init",
    "hostname": "string"
  },
  "id": "string",
  "modified": "2024-01-15T09:30:00Z",
  "name": "string",
  "node": "string",
  "reachability_check": null,
  "run_again_on_rebuild": true,
  "state": "NOT_READY",
  "wait_for_network": true
}
```

**SDK Code**

```python
import requests

url = "https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/id/"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/id/';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/id/"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/id/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/id/")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/id/', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/id/");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.dsx-air.nvidia.com/api/v3/simulations/nodes/instructions/id/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```